# Change Log

All notable changes to this project will be documented in this file. See [standard-version](https://github.com/conventional-changelog/standard-version) for commit guidelines.

<a name="1.9.2"></a>
## [1.9.2](https://github.com/derekhawker/react-informed/compare/v1.9.1...v1.9.2) (2017-10-26)


### Bug Fixes

* update field state when props are changed ([ad6b984](https://github.com/derekhawker/react-informed/commit/ad6b984))



<a name="1.9.1"></a>
## [1.9.1](https://github.com/derekhawker/react-informed/compare/v1.9.0...v1.9.1) (2017-10-24)


### Bug Fixes

* file input was writing an undefined prop name to form state ([fcbdceb](https://github.com/derekhawker/react-informed/commit/fcbdceb))



<a name="1.9.0"></a>
# [1.9.0](https://github.com/derekhawker/react-informed/compare/v1.8.1...v1.9.0) (2017-10-17)


### Features

* new Input Implementation to support type"file" ([72d3fef](https://github.com/derekhawker/react-informed/commit/72d3fef))



<a name="1.8.1"></a>
## [1.8.1](https://github.com/derekhawker/react-informed/compare/v1.8.0...v1.8.1) (2017-09-21)


### Bug Fixes

* debounced Fields did not update immediately after blur event ([a86acd7](https://github.com/derekhawker/react-informed/commit/a86acd7))



<a name="1.8.0"></a>
# [1.8.0](https://github.com/derekhawker/react-informed/compare/v1.7.3...v1.8.0) (2017-09-21)


### Features

* pulled the onBlur keyword out of the debounce property into its own property ([a5091c6](https://github.com/derekhawker/react-informed/commit/a5091c6))


### BREAKING CHANGES

* Field's debounce property does not allow "onBlur" as value
* blurring a component will trigger it's update if debounce is defined



<a name="1.7.3"></a>
## [1.7.3](https://github.com/derekhawker/react-informed/compare/v1.7.2...v1.7.3) (2017-09-15)


### Bug Fixes

* forgot to reset var that capture timer id in callback ([4481329](https://github.com/derekhawker/react-informed/commit/4481329))
* removed unnecessary render caused by Field with debounce ([e24d8eb](https://github.com/derekhawker/react-informed/commit/e24d8eb))



<a name="1.7.2"></a>
## [1.7.2](https://github.com/derekhawker/react-informed/compare/v1.7.1...v1.7.2) (2017-09-15)


### Bug Fixes

* removed extra calls to onChange events on Form and Field on initial render ([70c40be](https://github.com/derekhawker/react-informed/commit/70c40be))



<a name="1.7.1"></a>
## [1.7.1](https://github.com/derekhawker/react-informed/compare/v1.7.0...v1.7.1) (2017-09-13)


### Features

* Can now set the class on the <form> element ([cfa09fb](https://github.com/derekhawker/react-informed/commit/cfa09fb))



<a name="1.7.0"></a>
# [1.7.0](https://github.com/derekhawker/react-informed/compare/v1.6.1...v1.7.0) (2017-09-12)


### Bug Fixes

* was passing stale value of Field's value in onChange callback ([5e23d01](https://github.com/derekhawker/react-informed/commit/5e23d01))


### Features

* pass formState as param in onSubmit callback ([bd8b548](https://github.com/derekhawker/react-informed/commit/bd8b548))



<a name="1.6.1"></a>
## [1.6.1](https://github.com/derekhawker/react-informed/compare/v1.6.0...v1.6.1) (2017-08-28)



<a name="1.6.0"></a>
# [1.6.0](https://github.com/derekhawker/react-informed/compare/v1.5.1...v1.6.0) (2017-08-28)


### Features

* simplified <Field> props. name is not longer required ([03b7266](https://github.com/derekhawker/react-informed/commit/03b7266))



<a name="1.5.1"></a>
## [1.5.1](https://github.com/derekhawker/react-informed/compare/v1.5.0...v1.5.1) (2017-08-25)



<a name="1.5.0"></a>
# [1.5.0](https://github.com/derekhawker/react-informed/compare/v1.4.1...v1.5.0) (2017-08-25)


### Bug Fixes

* Field checks for errors on prop changes ([183b342](https://github.com/derekhawker/react-informed/commit/183b342))
* reject Form's submit if there are any form errors ([aec8130](https://github.com/derekhawker/react-informed/commit/aec8130))


### Features

* improved typing support for FormState ([6b3a9f0](https://github.com/derekhawker/react-informed/commit/6b3a9f0))
* New input field implementation for date inputs ([0a33b0b](https://github.com/derekhawker/react-informed/commit/0a33b0b))
* onSubmit can now be used to halt the submit action ([af4b166](https://github.com/derekhawker/react-informed/commit/af4b166))



<a name="1.4.1"></a>
## 1.4.1 (2017-08-24)


### Bug Fixes

* assigned wrong value for checkbox ([5046324](https://github.com/derekhawker/react-informed/commit/5046324))
* checkboxes nextInput() function would mutate state ([d883342](https://github.com/derekhawker/react-informed/commit/d883342))
* index.html was merged badly ([df8ed01](https://github.com/derekhawker/react-informed/commit/df8ed01))
* input type="password" needed to be added to supported input types ([5e0d861](https://github.com/derekhawker/react-informed/commit/5e0d861))
* misnamed prop ([4222408](https://github.com/derekhawker/react-informed/commit/4222408))
* Problem comparing values because of string to number comparisons ([9a73576](https://github.com/derekhawker/react-informed/commit/9a73576))
* readded some lost updates on mount ([57098d9](https://github.com/derekhawker/react-informed/commit/57098d9))
* remove handcoded error check to use the official error function ([88781c0](https://github.com/derekhawker/react-informed/commit/88781c0))
* removed logging ([4fd38ce](https://github.com/derekhawker/react-informed/commit/4fd38ce))
* Reversed link ([c5a6071](https://github.com/derekhawker/react-informed/commit/c5a6071))
* was using unconverted input values ([ea433cd](https://github.com/derekhawker/react-informed/commit/ea433cd))


### Features

* added a trim whitspace property on Field ([abb0ebe](https://github.com/derekhawker/react-informed/commit/abb0ebe))
* input radiobuttons can now be used in a Field ([1d02f2c](https://github.com/derekhawker/react-informed/commit/1d02f2c))
* Test for double submitted forms ([236b3cb](https://github.com/derekhawker/react-informed/commit/236b3cb))



<a name="1.4.0"></a>
# 1.4.0 (2017-08-24)


### Bug Fixes

* assigned wrong value for checkbox ([5046324](https://github.com/derekhawker/react-informed/commit/5046324))
* index.html was merged badly ([df8ed01](https://github.com/derekhawker/react-informed/commit/df8ed01))
* input type="password" needed to be added to supported input types ([5e0d861](https://github.com/derekhawker/react-informed/commit/5e0d861))
* misnamed prop ([4222408](https://github.com/derekhawker/react-informed/commit/4222408))
* remove handcoded error check to use the official error function ([88781c0](https://github.com/derekhawker/react-informed/commit/88781c0))
* removed logging ([4fd38ce](https://github.com/derekhawker/react-informed/commit/4fd38ce))
* Reversed link ([c5a6071](https://github.com/derekhawker/react-informed/commit/c5a6071))


### Features

* added a trim whitspace property on Field ([abb0ebe](https://github.com/derekhawker/react-informed/commit/abb0ebe))
* input radiobuttons can now be used in a Field ([1d02f2c](https://github.com/derekhawker/react-informed/commit/1d02f2c))
* Test for double submitted forms ([236b3cb](https://github.com/derekhawker/react-informed/commit/236b3cb))
