import * as React from "react";
import { FieldProps, FieldState } from "../Field";
import { InputFieldImpl } from "../types/InputFieldImpl";
import { FieldChild } from "../types/FieldChild";
export declare abstract class BaseInputField implements InputFieldImpl, FieldChild {
    protected updateField: (state: FieldState, isFirstRender?: boolean) => void;
    protected onBlur: () => void;
    protected getProps: () => FieldProps;
    protected getState: () => FieldState;
    protected originalValue: any;
    protected name: string;
    constructor(updateField: (state: FieldState, isFirstRender?: boolean) => void, onBlur: () => void, getProps: () => FieldProps, getState: () => FieldState, originalValue: any, name: string);
    abstract renderProps(value: string): {
        [prop: string]: any;
    };
    abstract nextInput(value: React.FormEvent<HTMLInputElement>, dirty: boolean): FieldState;
    render(): React.ReactElement<any>;
    propsUpdate(): void;
    protected handleInputBlur(): void;
    protected handleInputChange(e: React.FormEvent<HTMLInputElement>): void;
    private update(e, dirty, isFirstRender);
}
