"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var helpers_1 = require("./helpers");
var BaseInputField = (function () {
    function BaseInputField(updateField, onBlur, getProps, getState, originalValue, name) {
        this.updateField = updateField;
        this.onBlur = onBlur;
        this.getProps = getProps;
        this.getState = getState;
        this.originalValue = originalValue;
        this.name = name;
        this.handleInputChange = this.handleInputChange.bind(this);
        this.handleInputBlur = this.handleInputBlur.bind(this);
        // Initialize input (check errors)
        var state = this.getState();
        this.update({ currentTarget: { value: state.value, checked: state.value } }, false, true);
    }
    BaseInputField.prototype.render = function () {
        var props = this.getProps(), state = this.getState();
        var child = React.Children.only(props.children);
        return React.cloneElement(child, __assign({}, this.renderProps(state.value), { id: this.name, name: this.name, onBlur: this.handleInputBlur }));
    };
    BaseInputField.prototype.propsUpdate = function () {
        var state = this.getState();
        var nx = this.nextInput({ currentTarget: { value: state.value, checked: state.value } }, state.input.dirty);
        if (nx.input.value !== state.input.value ||
            nx.input.error !== state.input.error ||
            nx.input.dirty !== state.input.dirty ||
            nx.input.changed !== state.input.changed ||
            nx.input.honestError !== state.input.honestError) {
            var nextState = __assign({}, state, nx);
            this.updateField(nextState);
        }
    };
    BaseInputField.prototype.handleInputBlur = function () {
        var props = this.getProps();
        if (helpers_1.isAsync(props))
            this.onBlur();
    };
    BaseInputField.prototype.handleInputChange = function (e) {
        this.update(e, true, false);
    };
    BaseInputField.prototype.update = function (e, dirty, isFirstRender) {
        var next = this.nextInput(e, dirty);
        this.updateField(next, isFirstRender);
    };
    return BaseInputField;
}());
exports.BaseInputField = BaseInputField;
