"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BaseInputField_1 = require("../BaseInputField");
var validations_1 = require("../validations");
var DateInputField = (function (_super) {
    __extends(DateInputField, _super);
    function DateInputField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DateInputField.prototype.renderProps = function (value) {
        var onChange = this.handleInputChange;
        return {
            value: value || "",
            onChange: onChange,
        };
    };
    DateInputField.prototype.nextInput = function (ev, dirty) {
        var value = ev.currentTarget.value;
        var honestError = this.getErrors(value);
        return {
            value: value,
            input: {
                name: this.name,
                value: value,
                dirty: dirty,
                honestError: honestError,
                error: dirty ? honestError : 0,
                changed: value !== this.originalValue,
            },
        };
    };
    DateInputField.prototype.getErrors = function (value) {
        var props = this.getProps();
        var err = 0;
        err = validations_1.checkTextRequired(props, value);
        if (err)
            return err;
        err = validations_1.checkValidate(props, value);
        if (err)
            return err;
        return 0;
    };
    return DateInputField;
}(BaseInputField_1.BaseInputField));
exports.DateInputField = DateInputField;
