"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var BaseInputField_1 = require("../BaseInputField");
var validations_1 = require("../validations");
var FileInputField = (function (_super) {
    __extends(FileInputField, _super);
    function FileInputField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FileInputField.prototype.renderProps = function (value) {
        var onChange = this.handleInputChange;
        return {
            onChange: onChange,
        };
    };
    FileInputField.prototype.nextInput = function (ev, dirty) {
        var value = ev.currentTarget.files;
        if (value === undefined && this.getState().input !== undefined)
            return this.getState();
        var honestError = this.getErrors(value);
        return {
            value: value,
            input: {
                name: this.name,
                value: value,
                dirty: dirty,
                honestError: honestError,
                error: dirty ? honestError : 0,
                changed: value !== this.originalValue,
            },
        };
    };
    FileInputField.prototype.handleInputChange = function (e) {
        var state = this.getState();
        var input = this.nextInput(e, true);
        var nextState = __assign({}, state, input);
        var onChange = this.getProps().onChange;
        if (onChange)
            onChange(e);
        this.updateField(nextState);
    };
    FileInputField.prototype.getErrors = function (value) {
        var props = this.getProps();
        var err = 0;
        err = validations_1.checkTextRequired(props, value);
        if (err)
            return err;
        err = validations_1.checkValidate(props, value);
        if (err)
            return err;
        return 0;
    };
    return FileInputField;
}(BaseInputField_1.BaseInputField));
exports.FileInputField = FileInputField;
