"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var InputRadioField = (function () {
    function InputRadioField(onChange, getProps, getState, getContext) {
        this.onChange = onChange;
        this.getProps = getProps;
        this.getState = getState;
        this.getContext = getContext;
        this.handleInputChange = this.handleInputChange.bind(this);
    }
    InputRadioField.prototype.render = function () {
        var _this = this;
        var props = this.getProps(), state = this.getState();
        return (React.createElement("div", null, React.Children.map(props.children, function (c) {
            var child = c;
            var onChange = _this.handleInputChange;
            if (child.type === "input" && child.props.type === "radio") {
                return React.cloneElement(child, {
                    name: props.name,
                    checked: state.value == child.props.value,
                    id: child.props.value,
                    onChange: onChange
                });
            }
            else {
                return child;
            }
        })));
    };
    InputRadioField.prototype.componentDidMount = function () {
        var state = this.getState();
        var input = this.nextInput(state.value, false);
        return { input: input };
    };
    InputRadioField.prototype.componentDidUpdate = function (prevProps, prevState) { };
    InputRadioField.prototype.handleInputChange = function (e) {
        var state = this.getState();
        var value = e.currentTarget.value;
        var input = this.nextInput(value, true);
        var nextState = __assign({}, state, { value: value, input: input });
        this.onChange(nextState);
    };
    InputRadioField.prototype.nextInput = function (value, dirty) {
        var props = this.getProps(), state = this.getState();
        return {
            name: props.name,
            value: value,
            dirty: dirty,
            honestError: 0,
            error: 0,
            changed: value !== state.originalValue,
        };
    };
    return InputRadioField;
}());
exports.InputRadioField = InputRadioField;
