"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var BaseInputField_1 = require("../BaseInputField");
var validations_1 = require("../validations");
var RadioButtonInputField = (function (_super) {
    __extends(RadioButtonInputField, _super);
    function RadioButtonInputField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /** Not used. Because the render method is overwritten. */
    RadioButtonInputField.prototype.renderProps = function (value) {
        return {};
    };
    RadioButtonInputField.prototype.render = function () {
        var _this = this;
        var props = this.getProps(), state = this.getState();
        return (React.createElement("div", null, React.Children.map(props.children, function (c) {
            var child = c;
            var onChange = _this.handleInputChange;
            if (child.type === "input" && child.props.type === "radio") {
                return React.cloneElement(child, {
                    name: _this.name,
                    checked: state.value == child.props.value,
                    id: child.props.value,
                    onChange: onChange,
                });
            }
            else {
                return child;
            }
        })));
    };
    RadioButtonInputField.prototype.nextInput = function (ev, dirty) {
        var value = ev.currentTarget.value;
        var honestError = this.getErrors(value);
        return {
            value: value,
            input: {
                name: this.name,
                value: value,
                dirty: dirty,
                honestError: honestError,
                error: dirty ? honestError : 0,
                changed: value !== this.originalValue,
            },
        };
    };
    RadioButtonInputField.prototype.getErrors = function (value) {
        var props = this.getProps();
        var err = 0;
        err = validations_1.checkTextRequired(props, value);
        if (err)
            return err;
        err = validations_1.checkStringBounds(props, value);
        if (err)
            return err;
        err = validations_1.checkRegex(props, value);
        if (err)
            return err;
        err = validations_1.checkValidate(props, value);
        if (err)
            return err;
        return 0;
    };
    return RadioButtonInputField;
}(BaseInputField_1.BaseInputField));
exports.RadioButtonInputField = RadioButtonInputField;
