"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validations_1 = require("../../input/validations");
var BaseInputField_1 = require("../../input/BaseInputField");
var CheckboxInputField = (function (_super) {
    __extends(CheckboxInputField, _super);
    function CheckboxInputField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CheckboxInputField.prototype.renderProps = function (value) {
        var onChange = this.handleInputChange;
        return {
            onChange: onChange,
            checked: value,
        };
    };
    CheckboxInputField.prototype.nextInput = function (ev, dirty) {
        var props = this.getProps(), state = this.getState();
        var boolValue = ev.currentTarget.checked === undefined ? false : ev.currentTarget.checked;
        var honestError = this.getErrors(boolValue);
        return {
            value: boolValue,
            input: {
                name: props.name,
                value: boolValue,
                dirty: dirty,
                honestError: honestError,
                error: dirty ? honestError : 0,
                changed: boolValue !== state.originalValue,
            }
        };
    };
    CheckboxInputField.prototype.getErrors = function (value) {
        var props = this.getProps();
        var err = 0;
        err = validations_1.checkCheckboxRequired(props, value);
        if (err)
            return err;
        err = validations_1.checkValidate(props, value);
        if (err)
            return err;
        return 0;
    };
    return CheckboxInputField;
}(BaseInputField_1.BaseInputField));
exports.CheckboxInputField = CheckboxInputField;
