"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validations_1 = require("../../input/validations");
var BaseInputField_1 = require("../../input/BaseInputField");
var EmailInputField = (function (_super) {
    __extends(EmailInputField, _super);
    function EmailInputField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EmailInputField.prototype.renderProps = function (value) {
        var onChange = this.handleInputChange;
        return {
            value: value || "",
            onChange: onChange
        };
    };
    EmailInputField.prototype.nextInput = function (ev, dirty) {
        var props = this.getProps(), state = this.getState();
        var value = ev.currentTarget.value;
        var trimmed = props.trimWhitespace ? value.trim() : value;
        var honestError = this.getErrors(trimmed);
        return {
            value: value,
            input: {
                name: props.name,
                value: trimmed,
                dirty: dirty,
                honestError: honestError,
                error: dirty ? honestError : 0,
                changed: trimmed !== state.originalValue,
            }
        };
    };
    EmailInputField.prototype.getErrors = function (value) {
        var props = this.getProps();
        var err = 0;
        err = validations_1.checkTextRequired(props, value);
        if (err)
            return err;
        err = validations_1.checkStringBounds(props, value);
        if (err)
            return err;
        err = validations_1.checkEmail(props, value);
        if (err)
            return err;
        err = validations_1.checkRegex(props, value);
        if (err)
            return err;
        err = validations_1.checkValidate(props, value);
        if (err)
            return err;
        return 0;
    };
    return EmailInputField;
}(BaseInputField_1.BaseInputField));
exports.EmailInputField = EmailInputField;
