"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var validations_1 = require("../../input/validations");
var BaseInputField_1 = require("../../input/BaseInputField");
var NumberInputField = (function (_super) {
    __extends(NumberInputField, _super);
    function NumberInputField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NumberInputField.prototype.renderProps = function (value) {
        var onChange = this.handleInputChange;
        return {
            value: value === null ? "" : ("" + value),
            onChange: onChange
        };
    };
    NumberInputField.prototype.nextInput = function (ev, dirty) {
        var props = this.getProps(), state = this.getState();
        var value = ev.currentTarget.value;
        var cast = conv(value);
        var honestError = this.getErrors(cast);
        return {
            value: cast,
            input: {
                name: props.name,
                value: cast,
                dirty: dirty,
                honestError: honestError,
                error: dirty ? honestError : 0,
                changed: cast !== conv(state.originalValue),
            }
        };
        function conv(v) {
            return (!v || v.length === 0) ? null : +v;
        }
    };
    NumberInputField.prototype.getErrors = function (value) {
        var props = this.getProps();
        var err = 0;
        err = validations_1.checkNumberRequired(props, value);
        if (err)
            return err;
        if (value === null)
            return 0; // All below error check pass because input is invalid. Required
        err = validations_1.checkNumericBounds(props, value);
        if (err)
            return err;
        err = validations_1.checkValidate(props, value);
        if (err)
            return err;
        return 0;
    };
    return NumberInputField;
}(BaseInputField_1.BaseInputField));
exports.NumberInputField = NumberInputField;
