import * as React from "react";
import { FieldProps, FieldState } from "../Field";
export declare abstract class BaseInputField {
    protected updateField: (state: Pick<FieldState, keyof FieldState>) => void;
    protected onBlur: () => void;
    protected getProps: () => FieldProps;
    protected getState: () => FieldState;
    protected abstract getErrors(value: any): number;
    protected abstract renderProps(value: string): {
        [prop: string]: any;
    };
    protected abstract nextInput(value: any, dirty: boolean): any;
    constructor(updateField: (state: Pick<FieldState, keyof FieldState>) => void, onBlur: () => void, getProps: () => FieldProps, getState: () => FieldState);
    render(): React.ReactElement<any>;
    componentDidMount(): Partial<Pick<FieldState, keyof FieldState>>;
    protected handleInputBlur(): void;
    protected handleInputChange(e: React.FormEvent<HTMLInputElement>): void;
}
