"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var BaseInputField = (function () {
    function BaseInputField(updateField, onBlur, getProps, getState) {
        this.updateField = updateField;
        this.onBlur = onBlur;
        this.getProps = getProps;
        this.getState = getState;
        this.handleInputChange = this.handleInputChange.bind(this);
        this.handleInputBlur = this.handleInputBlur.bind(this);
    }
    BaseInputField.prototype.render = function () {
        var props = this.getProps(), state = this.getState();
        var child = React.Children.only(props.children);
        var onBlur = (props.debounce !== undefined && props.debounce === "onBlur") ? this.handleInputBlur : undefined;
        return React.cloneElement(child, __assign({}, this.renderProps(state.value), { id: props.name, name: props.name, onBlur: onBlur }));
    };
    BaseInputField.prototype.componentDidMount = function () {
        var state = this.getState();
        var input = this.nextInput({ currentTarget: { value: state.value, checked: state.value } }, false);
        return __assign({}, input);
    };
    BaseInputField.prototype.handleInputBlur = function () {
        var props = this.getProps();
        var onBlur = (props.debounce !== undefined && props.debounce === "onBlur");
        if (onBlur)
            this.onBlur();
    };
    BaseInputField.prototype.handleInputChange = function (e) {
        var state = this.getState();
        var input = this.nextInput(e, true);
        var nextState = __assign({}, state, input);
        this.updateField(nextState);
    };
    return BaseInputField;
}());
exports.BaseInputField = BaseInputField;
