import { InputState } from "./InputState";
export interface BaseForm {
    /** true if the form was submitted. */
    isSubmitted: boolean;
    /** true if any of the form fields have errors. If a field can only have an error if it is dirty.  */
    isError: boolean;
    /** true if there are no errors on any fields. Unlike isError, this checks fields regardless of their dirty flag. */
    isValid: boolean;
    /** true if the form values are different from their original values */
    isChanged: boolean;
    [k: string]: InputState<any> | boolean | undefined;
}
