import * as React from "react";

export enum CustomObjectError {
    MessageIsNumber = 10001,
    MessageIsTooLong = 10002,
}

export interface CustomComponentProps {
    value?: CustomObject;

    onChange?: (value: CustomObject) => void;
}

export interface CustomObject {
    id: number;
    message: string;
}

export class CustomComponent extends React.Component<CustomComponentProps, any> {

    constructor(props: CustomComponentProps) {
        super(props);

        this.handleChange = this.handleChange.bind(this);
    }

    public render() {
        let { value } = this.props;
        return (
            <div>
                <label>{(value as any).id}</label>
                <input value={(value as any).message} onChange={this.handleChange}/>
            </div>);
    }

    public componentWillReceiveProps(nextProps: CustomComponentProps) {
        this.setState({ value: nextProps.value });
    }

    public handleChange(e: React.FormEvent<HTMLInputElement>) {
        let value = e.currentTarget.value || "";
        this.setState({ value });
        if (this.props.onChange) this.props.onChange({ id: 0, message: value });
    }
}
