import * as React from "react";
import {BaseForm, Field, Form, formState, InputState} from "react-informed";

export interface UserInfoForm extends BaseForm {
    invalid1: InputState<string>;
    invalid2: InputState<string>;
    invalid3: InputState<string>;
    invalid4: InputState<string>;
}

export interface InvalidFormState {
    form: UserInfoForm;
}

export class InvalidForm extends React.Component<any, InvalidFormState> {

    constructor(props: any) {
        super(props);

        this.handleFormChanged = this.handleFormChanged.bind(this);
        this.resetSubmitted = this.resetSubmitted.bind(this);

        this.state = {
            form: formState({
                invalid1: "invalid1",
                invalid2: "invalid2",
                invalid3: "invalid3",
                invalid4: "invalid4",
            }),
        };
    }

    public render() {
        let { form } = this.state;
        return (
            <div>
                <Form formState={form}
                      preventAction={true}
                      onChange={this.handleFormChanged}>

                    <div>
                        <Field value={form.invalid1}>
                            <input type="text"/>
                            <input type="text"/>
                        </Field>
                    </div>

                    <div>
                        <Field value={form.invalid2}>
                            <input type="button"/>
                        </Field>
                    </div>
                    <div>
                        <Field value={form.invalid3}>
                            <input type="reset"/>
                        </Field>
                    </div>
                    <div>
                        <Field value={form.invalid4}>
                            <input type="submit"/>
                        </Field>
                    </div>
                </Form>
            </div>);
    }

    private handleFormChanged(form: UserInfoForm) {
        this.setState({ form });
    }

    private resetSubmitted() {
        this.setState({ form: { ...this.state.form, isSubmitted: false } });
    }
}


