import * as path from "path";
import * as webpack from "webpack";

export default function (env: { dev: boolean; production: boolean }): webpack.Configuration {
    let rules: Array<webpack.Rule> = [
        {
            test : /\.ts(x?)$/,
            use : [
                'ts-loader'
            ]
        },
    ];

    let plugins = [
        new webpack.ProvidePlugin({}),
    ];
    if (env.production) {
        plugins.push(new webpack.optimize.UglifyJsPlugin({
            sourceMap : true
        }));
    }
    return {
        entry :  "./src/index.tsx",
        output : {
            filename : 'dist/bundle.js',
            path : path.resolve(__dirname)
        },
        devtool : 'source-map',
        resolve : {
            extensions : ['.ts', ".tsx", '.js', '.json'],
            modules : [__dirname, path.resolve(__dirname, "src"), "node_modules"],
        },
        plugins,
        module : { rules },
    };
};

